<?php
/*
addon_avatar.php : avatars addon file for miniBB.
This file is part of miniBB. miniBB is free discussion forums/message board software, supplied with no warranties.
Check COPYING file for more details.
Copyright (C) 2004-2020 Paul Puzyrev. www.minibb.com
Latest File Update: 2020-Jun-05
*/
if (!defined('INCLUDED776')) die ('Fatal error.');

include($pathToFiles.'addon_avatar_options.php');

if(isset($_GET['adminUser'])) $adminUser=(integer)$_GET['adminUser']+0; elseif(isset($_POST['adminUser'])) $adminUser=(integer)$_POST['adminUser']+0; else $adminUser=0;

$editedMod=FALSE;
if(isset($mods)){
foreach($mods as $k=>$v) if(in_array($adminUser,$v)) { $editedMod=TRUE; break; }
}

$tmpUser=$user_id;
if($adminUser>1 and ($user_id==1 or ($isMod==1 and $adminUser!=$user_id and !$editedMod) ) ) {
if(!defined('ADMIN_USER_TMP')) define('ADMIN_USER_TMP', $adminUser);
$user_id=$adminUser;
$adminUserLnk='&amp;adminUser='.$adminUser;
$adminUserLnkC='&adminUser='.$adminUser;
}
else {
$adminUserLnk=''; $adminUserLnkC=''; $adminUser=0;
}

if($user_id!=0){

if($user_id==1 and isset($_GET['deleteAvatarsDir'])) { rmdir($avatarDir); exit; }

//attempt to create/chmod avatars folder
/*
if($avatarMaxFileSize>0 and !is_dir($avatarDir)) {
umask(002);
mkdir($avatarDir,0777);
}
*/

if($avatarMaxFileSize>0){
if(!is_dir($avatarDir) or !is_writable($avatarDir)) die('Avatar plugin is set up to work with uploaded files, but the folder '.$avatarDir.' is not available to write or doesn\'t exist. Can not continue - please, check your settings and file permissions first!');
}

if($GLOBALS['enableProfileUpdate'] and $user_id>0){

$fName=$pathToFiles.'lang/avatars_'.$lang.'.php';
if(file_exists($fName)) include($fName); else include($pathToFiles.'lang/avatars_eng.php');

function deleteAvatar($userID, $avatarDir, $avatarAvailableTypes, $fullDel=TRUE){

if($fullDel){
if ($handle = opendir($avatarDir)) {
while (false !== ($filey = readdir($handle))) {
if ($filey != '.' and $filey != '..') {
$fid=(int)$filey;
if($fid==$userID) unlink("{$avatarDir}/{$filey}");
}
}
closedir($handle);
}
}
else{
foreach($avatarAvailableTypes as $ext=>$mime) if(file_exists($avatarDir.'/'.$userID.'.'.$ext)) unlink($avatarDir.'/'.$userID.'.'.$ext);
}

}

if($action=='prefs' or $action=='editprefs'){

$curr=db_simpleSelect(0,$Tu,$avatarDbField,$dbUserId,'=',$user_id);
$curr=$curr[0];

/* Displaying form */
$delLink=0;
if($curr!='' and strlen($curr)==3 and file_exists($avatarDir.'/'.$user_id.'.'.$curr)) {
$avatar="<img src=\"{$avatarUrl}/{$user_id}.{$curr}?".date('His')."\" alt=\"\" title=\"\">";
$delLink=1;
}
elseif($curr!='' and substr_count($curr, '.')>0){
$avatar="<img src=\"{$main_url}/img/forum_avatars/{$curr}\" alt=\"{$curr}\" title=\"{$curr}\">";
$delLink=1;
}
else {
$avatar='';
}

if($delLink==1) {
$csrfchk=$_COOKIE[$cookiename.'_csrfchk'];
$avatarDel="<a href=\"{$main_url}/{$indexphp}action=avatardelete&amp;csrfchk={$csrfchk}{$adminUserLnk}\" class=\"mnblnk\">$l_deleteAvatar</a>";
} else $avatarDel='';

$aTpl=makeUp('addon_avatar_userform');
if(isset($is_mobile) and $is_mobile and $avatar=='') $aTpl=preg_replace("#<!--noAvatar-->(.+?)<!--/noAvatar-->#is", '', $aTpl);

if($avatarMaxFileSize==0) $aTpl=preg_replace("#<!--avatar_upload_link-->(.+?)<!--/avatar_upload_link-->#is", '', $aTpl);
if($chooseTableCells==0) $aTpl=preg_replace("#<!--avatar_list_link-->(.+?)<!--/avatar_list_link-->#is", '', $aTpl);
$avatarForm=ParseTpl($aTpl);
}

/* upload avatar - step 1 */

elseif($action=='avatarupload1' and $avatarMaxFileSize>0){

$title.=$l_uploadAvatar;

$aTpl=makeUp('addon_avatar_upload');
if(isset($is_mobile) and $is_mobile) $aTpl=preg_replace('#<!--main_url-->(.+?)<!--/main_url-->#', '', $aTpl);
else $aTpl=preg_replace('#<!--mobile_only-->(.+?)<!--/mobile_only-->#', '', $aTpl);

$sizeKb=floor($avatarMaxFileSize/1024);

if($maxAvatarWidth>0 and $maxAvatarHeight>0) {
if($staticAvatarSize) $aTpl=preg_replace("#<!--VARY_SIZE-->(.+?)<!--/VARY_SIZE-->#is", '', $aTpl);
else $aTpl=preg_replace("#<!--STATIC_SIZE-->(.+?)<!--/STATIC_SIZE-->#is", '', $aTpl);
}

echo load_header();
echo ParseTpl($aTpl);
return;

}

/* upload avatar - step 2 */

elseif($action=='avatarupload2' and $avatarMaxFileSize>0){
$warn=0;

if(isset($_FILES['userfile']) and is_uploaded_file($_FILES['userfile']['tmp_name'])){

function getFileExt($file_name){
//we suppose each extension should have at most 4 chars and they should be in [a-z0-9] range
if(substr_count($file_name, '.')==0) return '';
else{
$expl=explode('.', $file_name);
$expls=sizeof($expl)-1;
$ext=$expl[$expls];
if(preg_match('#[^a-z0-9]+#', $ext)) return '';
if(strlen($ext)>4) return '';
else return $ext;
}
}

$file_type=strtolower($_FILES['userfile']['type']);

$file_size=$_FILES['userfile']['size'];

$file_ext=getFileExt($_FILES['userfile']['name']);

$access=FALSE;

if(isset($avatarAvailableTypes[$file_ext]) and in_array($file_type, $avatarAvailableTypes[$file_ext])) $access=TRUE;

$iWidth=0; $iHeight=0;

if($access and function_exists('getimagesize')) {
$size=@getimagesize($_FILES['userfile']['tmp_name']);
$iWidth=(int)$size[0]; $iHeight=(int)$size[1];
//if($size['mime']!=$_FILES['userfile']['type']) $gotSize=FALSE; else $gotSize=TRUE;
$gotSize=TRUE;
}
else $gotSize=FALSE;

$malicious=TRUE;
if($access and $gotSize) $malicious=scanFilePHP($_FILES['userfile']['tmp_name']);

if(!$access or !$gotSize or $malicious or $_FILES['userfile']['size']>$avatarMaxFileSize or ($gotSize and ($iWidth>$maxAvatarWidth or $iHeight>$maxAvatarHeight or $iWidth==0 or $iHeight==0))){
$warn=1;
}
elseif($staticAvatarSize and $iWidth!=$maxAvatarWidth and $iHeight!=$maxAvatarHeight) {
$warn=1;
}
else {
/* Finally, we done all checkings - and mark avatar in user's info as uploaded.*/

deleteAvatar($user_id, $avatarDir, $avatarAvailableTypes, FALSE);

umask(0);
if(move_uploaded_file($_FILES['userfile']['tmp_name'], "{$avatarDir}/{$user_id}.{$file_ext}")){
$$avatarDbField=$file_ext;
chmod("{$avatarDir}/{$user_id}.{$file_ext}", 0777);
updateArray(array($avatarDbField),$Tu,$dbUserId,$user_id);
}

}//preg

}//upl.
else $warn=1;

if($warn==1){
$errorMSG=$l_uploadError;
$correctErr="<a href=\"{$main_url}/{$indexphp}action=prefs{$adminUserLnk}\" class=\"mnblnk\">{$l_editPrefs}</a>";
$topicsLink="<a href=\"{$main_url}/{$indexphp}action=avatarupload1\" class=\"mnblnk\">{$l_uploadAvatar}</a>{$brtag}";
echo load_header();
echo ParseTpl(makeUp('main_warning'));
return;
}
else { header("Location: {$main_url}/{$indexphp}action=prefs{$adminUserLnkC}&avatar=1#avatar"); exit; }

}//upl2

/* delete avatar from info */

elseif($action=='avatardelete' and $csrfchk!='' and $csrfchk==$_COOKIE[$cookiename.'_csrfchk']){
$$avatarDbField='';
updateArray(array($avatarDbField),$Tu,$dbUserId,$user_id);

deleteAvatar($user_id, $avatarDir, $avatarAvailableTypes, TRUE);

header("Location: {$main_url}/{$indexphp}action=prefs{$adminUserLnkC}#avatar"); exit;
}

/* choose avatar from list - step 1 */

elseif($action=='avatarchoose1' and $chooseTableCells>0){
$title.=$l_chooseAvatar;

$avatarsList='<table class="tbTransparent w100">';

if (is_dir($pathToFiles.'img/forum_avatars/') and $handle=opendir($pathToFiles.'img/forum_avatars/')) {
$filesArray=array();
while(($file=readdir($handle))!=false) {
if($file!='.' and $file!='..' and (substr($file, -4)=='.gif' OR substr($file, -4)=='.jpg' OR substr($file, -4)=='.png')) {
$filesArray[]=$file;
}
}
closedir($handle);

asort($filesArray);

$a=1;
foreach($filesArray as $file){
if($a==1) $avatarsList.='<tr>';
if(isset($is_mobile) and $is_mobile) $fileTitle='';
else $fileTitle=$brtag.substr($file, 0, strlen($file)-4);

$avatarsList.="<td style=\"text-align:center;vertical-align:top\"><a href=\"{$main_url}/{$indexphp}action=avatarchoose2&amp;avatar=".urldecode($file)."{$adminUserLnk}\"><img src=\"{$main_url}/img/forum_avatars/{$file}\" alt=\"{$l_chooseAvatar}\" /></a></td>";

$a++;
if($a>$chooseTableCells) { $avatarsList.='</tr>'; $a=1; }
}

$a--;
if($a>0) {
for($i=$chooseTableCells; $i>$a; $i--) {
$avatarsList.='<td>&nbsp;</td>';
}
$avatarsList.='</tr>';
}
$avatarsList.='</table>';

}

echo load_header();

$aTpl=makeUp('addon_avatar_choose');
if(isset($is_mobile) and $is_mobile) $aTpl=preg_replace('#<!--main_url-->(.+?)<!--/main_url-->#', '', $aTpl);
else $aTpl=preg_replace('#<!--mobile_only-->(.+?)<!--/mobile_only-->#', '', $aTpl);

echo ParseTpl($aTpl);
return;
}

elseif($action=='avatarchoose2' and $chooseTableCells>0){
$avFile=urldecode(str_replace(array('/','\\'), '', $_GET['avatar']));
if(file_exists($pathToFiles."img/forum_avatars/{$avFile}")) {
$$avatarDbField=$avFile;
updateArray(array($avatarDbField),$Tu,$dbUserId,$user_id);
deleteAvatar($user_id, $avatarDir, $avatarAvailableTypes, FALSE);
}
header("Location: {$main_url}/{$indexphp}action=prefs{$adminUserLnkC}&avatar=1#avatar"); exit;
}

elseif($action=='removeuser' and isset($_POST['step']) and $_POST['step']=='remove' and ($isMod==1 or $user_id==1) and $csrfchk!='' and $csrfchk==$_COOKIE[$cookiename.'_csrfchk']) {
$userID=(isset($_POST['user'])?(integer)$_POST['user']+0:0);
deleteAvatar($userID, $avatarDir, $avatarAvailableTypes, FALSE);
}

elseif(defined('ADMIN_PANEL') and $action=='searchusers2' and isset($_POST['delus']) and is_array($_POST['delus']) and sizeof($_POST['delus'])>0) {

$delUsers=$_POST['delus'];

foreach($delUsers as $userID){
$userID=(int)$userID+0;
deleteAvatar($userID, $avatarDir, $avatarAvailableTypes, FALSE);
}

}

elseif($action=='delAvatarAdmin' and ($user_id==1 or $isMod==1) and $csrfchk!='' and $csrfchk==$_COOKIE[$cookiename.'_csrfchk']) {
$userID=(integer)$_GET['user']+0;
$$avatarDbField='';
updateArray(array($avatarDbField),$Tu,$dbUserId,$userID);
deleteAvatar($userID, $avatarDir, $avatarAvailableTypes, FALSE);
if($topic==0) $action='userinfo'; else $action='vthread';
}

elseif($action!='vthread' and $action!='userinfo'){
header("Location: {$main_url}/{$indexphp}action=prefs{$adminUserLnkC}#avatar"); exit;
}

}

if(defined('ADMIN_USER_TMP')) $user_id=$tmpUser;

}
/*
else die('Login failed. If you have changed your password, please re-login on the <a href="'.$main_url.'/'.$indexphp.'">main forums page.</a>');
*/

?>